const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    delete: _delete
};

/**
 * Format an array of routeAdministrations by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} routeAdministrations - The array of routeAdministrations to format.
 * @returns {Promise<Object[]>} - The formatted array of routeAdministrations.
 */
const formatWithModifier = async (routeAdministrations) => {
    return Promise.all(
        routeAdministrations.map(async (routeAdministration) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: routeAdministration.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...routeAdministration,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Retrieves all routeAdministrations with their parent routeAdministration title.
 * @param {Object} params - The query parameters.
 * @param {number[]} params.routeAdministrationsId - The ids of the routeAdministrations to retrieve.
 * @returns {Promise<Object>} - The response object with the routeAdministrations and success status.
 */
async function getAll(params) {
    try {
        // filters
        const filterConditions = {};

        let routeAdministrations = []
        routeAdministrations = await dbSAPPS.RouteAdministration.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
        });

        routeAdministrations = routeAdministrations.map(routeAdministration => {
            return {
                ...routeAdministration.dataValues
            }
        });

        routeAdministrations = await formatWithModifier(routeAdministrations);

        return {
            routeAdministrations,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Get routeAdministration items with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the routeAdministration items.
 * @param {boolean|string} params.is_parent - A boolean or string indicating whether the routeAdministration items should be parents or not.
 * @returns {Promise<Object>} Resolves with an object that contains the routeAdministration items and a success flag.
 * @example
 * const result = await option({ is_parent: true });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        let options = [];
        options = await dbSAPPS.RouteAdministration.findAll({
            attributes: ['id', 'name', 'display_name'],
            where: filterConditions,
            order: [['name', 'ASC']]
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active routeAdministration items
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */

async function count(params) {
    try {
        // filter
        const filterConditions = {};

        const count = await dbSAPPS.RouteAdministration.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new routeAdministration item.
 * 
 * @param {Object} params - The new routeAdministration item data.
 * @param {string} params.name - The name of the routeAdministration item.
 * @param {string} params.title - The title of the routeAdministration item.
 * @param {number} [params.parent_id] - The ID of the parent routeAdministration item.
 * @param {string} [params.url] - The URL of the routeAdministration item.
 * @param {string} [params.icon] - The icon of the routeAdministration item.
 * @param {string} [params.type=link] - The type of the routeAdministration item (link, group, collapse, separator).
 * @param {boolean} [params.enabled=true] - Whether the routeAdministration item is enabled.
 * @param {number} [params.creation=Date.now()] - The creation timestamp of the routeAdministration item.
 * @param {number} [params.modified=Date.now()] - The last modification timestamp of the routeAdministration item.
 * @param {number} [params.owner=1] - The ID of the user who created the routeAdministration item.
 * @param {number} [params.modified_by=1] - The ID of the user who last modified the routeAdministration item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the routeAdministration item creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingDisplayName = await dbSAPPS.RouteAdministration.findOne({
            where: { display_name: params.display_name },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.RouteAdministration.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing routeAdministration item.
 * 
 * @param {number} id - The ID of the routeAdministration item to update.
 * @param {Object} params - The updated routeAdministration item data.
 * @param {string} [params.name] - The new name of the routeAdministration item.
 * @param {string} [params.title] - The new title of the routeAdministration item.
 * @param {number} [params.parent_id] - The new parent ID of the routeAdministration item.
 * @param {string} [params.url] - The new URL of the routeAdministration item.
 * @param {string} [params.icon] - The new icon of the routeAdministration item.
 * @param {string} [params.type] - The new type of the routeAdministration item (link, group, collapse, separator).
 * @param {boolean} [params.enabled] - Whether the routeAdministration item is enabled or not.
 * @param {number} [params.creation] - The new creation timestamp of the routeAdministration item.
 * @param {number} [params.modified] - The new last modification timestamp of the routeAdministration item.
 * @param {number} [params.owner] - The new ID of the user who created the routeAdministration item.
 * @param {number} [params.modified_by] - The new ID of the user who last modified the routeAdministration item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the routeAdministration item update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const routeAdministration = await dbSAPPS.RouteAdministration.findByPk(id);
        if (!routeAdministration) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingDisplayName = await dbSAPPS.RouteAdministration.findOne({
            where: {
                display_name: params.display_name,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await routeAdministration.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a routeAdministration
 * @param {number} id - the id of the routeAdministration
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const routeAdministration = await dbSAPPS.RouteAdministration.findByPk(id);
        if (!routeAdministration) return { success: false, message: 'ID not found!' };

        // delete
        await routeAdministration.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
